package org.processmining.localprocessmodelconformance.plugins;

import org.processmining.acceptingpetrinet.models.AcceptingPetriNetArray;
import org.processmining.contexts.uitopia.annotations.UITopiaVariant;
import org.processmining.framework.plugin.PluginContext;
import org.processmining.framework.plugin.annotations.Plugin;
import org.processmining.framework.plugin.annotations.PluginCategory;
import org.processmining.framework.plugin.annotations.PluginVariant;
import org.processmining.lpm.util.LocalProcessModel;
import org.processmining.lpm.util.LocalProcessModelRanking;

@Plugin(name = "Convert Accepting Petri Net Array to Local Process Model Ranking", parameterLabels = { "Process Model Array" }, returnLabels = { "Local Process Model Ranking" }, returnTypes = {
		LocalProcessModelRanking.class }, userAccessible = true, categories = { PluginCategory.Enhancement })

public class ProcessModelArrayToLocalProcessModelRanking {
	
	@UITopiaVariant(affiliation = UITopiaVariant.EHV, author = "N. Tax", email = "n.tax@tue.nl", pack = "LocalProcessModelConformance")
	@PluginVariant(variantLabel = "Convert Accepting Petri Net Array to Local Process Model Ranking", requiredParameterLabels = { 0 })
	public LocalProcessModelRanking abstractLogBasedOnPatterns(PluginContext context, AcceptingPetriNetArray apna){
		LocalProcessModelRanking ranking = new LocalProcessModelRanking();
		for(int i=0; i<apna.getSize(); i++){
			LocalProcessModel lpm = new LocalProcessModel(apna.getNet(i));
			ranking.addNet(lpm);			
		}
		return ranking;
	}
}
